diff --git a/THANKS b/THANKS
index bbbcda6..eda9bba 100644
--- a/THANKS
+++ b/THANKS
@@ -2,4 +2,7 @@ gengen THANKS file
 
 Andrew SG Rojek
 Dinesh Shanbhag
-Bob White
\ No newline at end of file
+Bob White
+Nitharsan Rony (For his support
+and encouragement towards GNU Gengen's Lua)
+
diff --git a/src/cmdline.c b/src/cmdline.c
index 45bec91..4fe9796 100644
--- a/src/cmdline.c
+++ b/src/cmdline.c
@@ -37,7 +37,7 @@ const char *gengetopt_args_info_help[] = {
   "  -i, --input=file          input file (default std input)",
   "  -F, --file-name=name      name used for generating file (default stdout)",
   "  -f, --gen-name=STRING     prefix for generated code  (default=`gengen')",
-  "      --output-format=lang  target language (cpp, c)  (default=`cpp')",
+  "      --output-format=lang  target language (cpp, c, lua) (default=`cpp')",
   "      --output-dir=STRING   output directory (default current dir)",
   "      --separate-files      output to separate files (header, source). require \n                              --file-name",
   "      --expand-tabs         strings containing newlines are indented according \n                              to the current indentation level",
diff --git a/src/expressiongenerator_lua.cpp b/src/expressiongenerator_lua.cpp
new file mode 100644
index 0000000..7165432
--- /dev/null
+++ b/src/expressiongenerator_lua.cpp
@@ -0,0 +1,57 @@
+//
+// C++ Implementation: expressiongenerator_lua
+//
+// Description: output Lua interpretation of expressions
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#include "expressiongenerator_lua.h"
+#include "unaryexpression.h"
+#include "binaryexpression.h"
+#include "expressionoperators.h"
+
+#include <assert.h>
+
+ExpressionGeneratorLua::ExpressionGeneratorLua(std::ostream &o)
+  : out(&o)
+{
+  operatorMap[ANDOP] = "and";
+  operatorMap[OROP] = "or";
+  operatorMap[NOTOP] = "not";
+  operatorMap[LESSOP] = "<";
+  operatorMap[GREATEROP] = ">";
+  operatorMap[EQUALOP] = "==";
+  operatorMap[NEQUALOP] = "~=";
+  operatorMap[LESSEOP] = "<=";
+  operatorMap[GREATEREOP] = "=>";
+}
+
+
+void ExpressionGeneratorLua::visit(Expression *exp)
+{
+  *out << (exp->isConst() ? "" : prefix) << exp->getText();
+}
+
+void ExpressionGeneratorLua::visit(UnaryExpression *exp)
+{
+  assert(operatorMap.find(exp->getOperator()) != operatorMap.end());
+  
+  *out << "( " << operatorMap[exp->getOperator()] << " ";
+  ExpressionVisitor::visit(exp);
+  *out << " )";
+}
+
+void ExpressionGeneratorLua::visit(BinaryExpression *exp)
+{
+  assert(operatorMap.find(exp->getOperator()) != operatorMap.end());
+  
+  *out << "( ";
+  visit_DB(exp->getLeftExpression());
+  *out << " " << operatorMap[exp->getOperator()] << " ";
+  visit_DB(exp->getRightExpression());
+  *out << " )";
+}
diff --git a/src/expressiongenerator_lua.h b/src/expressiongenerator_lua.h
new file mode 100644
index 0000000..dda8921
--- /dev/null
+++ b/src/expressiongenerator_lua.h
@@ -0,0 +1,43 @@
+//
+// C++ Interface: expressiongenerator_lua
+//
+// Description: 
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#ifndef EXPRESSIONGENERATOR_LUA_H
+#define EXPRESSIONGENERATOR_LUA_H
+
+#include "expressionvisitor.hpp"
+
+#include <iostream>
+#include <map>
+#include <string>
+
+class ExpressionGeneratorLua : public ExpressionVisitor
+{
+  protected:
+    std::ostream *out;
+    typedef std::map<std::string, std::string> OperatorMap;
+    /// translation table for operators
+    OperatorMap operatorMap;
+    /// the prefix for non const base expressions, i.e., variables
+    std::string prefix;
+    
+  public:
+    ExpressionGeneratorLua(std::ostream &o);
+
+    void setStream(std::ostream &o) { out = &o; }
+    
+    virtual void visit(Expression *exp);
+    virtual void visit(UnaryExpression *exp);
+    virtual void visit(BinaryExpression *exp);
+    
+    void setPrefix(const std::string &p) { prefix = p; }
+};
+
+#endif
diff --git a/src/gengen.cc b/src/gengen.cc
index 9d9613d..3ec6f3d 100644
--- a/src/gengen.cc
+++ b/src/gengen.cc
@@ -28,6 +28,7 @@
 #include "skelstruct.hpp"
 #include "skelfactory_cpp.h"
 #include "skelfactory_c.h"
+#include "skelfactory_lua.h"
 #include "mainskelstruct.h"
 #include "mainskelfactory.h"
 #include "cmdline.h"
@@ -119,6 +120,11 @@ main(int argc, char **argv)
       skel_factory = new SkelFactoryC;
       source_ext = "c";
     }
+  else if (strcmp (args_info.output_format_arg, "lua") == 0)
+    {
+      skel_factory = new SkelFactoryLua;
+      source_ext = "lua";
+    }
   else
     {
       string serr = "target language ";
diff --git a/src/skelfactory_lua.cpp b/src/skelfactory_lua.cpp
new file mode 100644
index 0000000..fd6088d
--- /dev/null
+++ b/src/skelfactory_lua.cpp
@@ -0,0 +1,24 @@
+//
+//
+// C++ Implementation: skelfactory_lua
+//
+// Description:
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#include "skelfactory_lua.h"
+#include "skelstruct_lua.h"
+
+SkelStruct *
+SkelFactoryLua::createSkelStruct (SkelItems *items,
+                                const string &name, const string &file_name,
+                                StreamStruct &s, bool sep_files)
+{
+  return new SkelStructLua (items, name, file_name, s, sep_files);
+}
+
diff --git a/src/skelfactory_lua.h b/src/skelfactory_lua.h
new file mode 100644
index 0000000..31ffd53
--- /dev/null
+++ b/src/skelfactory_lua.h
@@ -0,0 +1,37 @@
+/*
+ * Raman Gopalan <ramangopalan@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
+
+#ifndef SKELFACTORY_LUA_H
+#define SKELFACTORY_LUA_H
+
+// implementation of pattern "Abstract Factory"
+// this generates Lua code
+
+#include "skelfactory.h"
+
+class SkelFactoryLua : public SkelFactory
+{
+ public:
+  virtual SkelStruct *createSkelStruct (SkelItems *items,
+                                        const string &name,
+                                        const string &file_name, StreamStruct &,
+                                        bool sep_files);
+};
+
+#endif // SKELFACTORY_LUA_H
diff --git a/src/skels/callextfun_lua.h_skel b/src/skels/callextfun_lua.h_skel
new file mode 100644
index 0000000..f7c73ea
--- /dev/null
+++ b/src/skels/callextfun_lua.h_skel
@@ -0,0 +1,6 @@
+
+if(record.@name@) then
+  generate_string(record.@name@, stream, indent + string.len(indent_str))
+else
+  generate_@name@(stream, record, indent + string.len(indent_str))
+end
diff --git a/src/skels/extern_function_lua.h_skel b/src/skels/extern_function_lua.h_skel
new file mode 100644
index 0000000..137acf3
--- /dev/null
+++ b/src/skels/extern_function_lua.h_skel
@@ -0,0 +1,8 @@
+
+generate_@name@ = function(stream, record, indent)
+--[[
+    This call back function will be executed if 'var'
+    associated with type 'method' is 'nil'. You could
+    add your Lua code here.
+--]]
+end
diff --git a/src/skels/genfunction_lua.h_skel b/src/skels/genfunction_lua.h_skel
new file mode 100644
index 0000000..defd4d6
--- /dev/null
+++ b/src/skels/genfunction_lua.h_skel
@@ -0,0 +1,21 @@
+function generate_@genname@(stream, record, indent)
+  local id = {}
+  local indent_str = ""
+  for i = 1, indent do
+    id[#id + 1] = ' '
+  end
+  indent_str = table.concat(id)
+  -- save context
+  local ctx = io.output()
+  io.output(stream)
+  @geninstructions:method{iteration=true}@
+
+  -- restore context
+  io.output(ctx)
+end
+
+function generatep_@genname@(stream, indent@genparameters:method@)
+  record = {}
+  @assignfields:method@
+  generate_@genname@(stream, record, indent)
+end
diff --git a/src/skels/genstrfunction_lua.h_skel b/src/skels/genstrfunction_lua.h_skel
new file mode 100644
index 0000000..f46b59f
--- /dev/null
+++ b/src/skels/genstrfunction_lua.h_skel
@@ -0,0 +1,18 @@
+
+function genstring_@genname@(record, indent)
+  local id = {}
+  local indent_str = ""
+  local output = ""
+  for i = 1, indent do
+    id[#id + 1] = ' '
+  end
+  indent_str = table.concat(id)
+  @strgeninstructions:method{iteration=true}@
+  return output;
+end
+
+function genstringp_@genname@(indent@genparameters:method@)
+  record = {}
+  @assignfields:method@
+  return genstring_@genname@ (record, indent);
+end
diff --git a/src/skels/genstringfun_lua.h_skel b/src/skels/genstringfun_lua.h_skel
new file mode 100644
index 0000000..bf9e128
--- /dev/null
+++ b/src/skels/genstringfun_lua.h_skel
@@ -0,0 +1,66 @@
+
+function strchr_tab(tab, char)
+  local store
+  local ret_str = ""
+  for w, k in ipairs(tab) do
+    if(k == char) then
+      store = w
+      break
+    end
+  end
+  if(store == nil) then
+    return nil
+  end
+  for i = store, #tab do
+    ret_str = ret_str .. tab[i]
+  end
+  return store, ret_str
+end
+
+function str_to_tab(str)
+  tab = {}
+  for i in string.gmatch(str, ".") do
+    table.insert(tab, i)
+  end
+  return tab
+end
+
+function generate_string(s, stream, indent)
+  local subs = s
+  local indent_str = ""
+  local id = {}
+  local pos = 0
+  local my_tab = str_to_tab(s)
+
+  -- save context
+  local ctx = io.output()
+  io.output(stream)
+
+  if((indent == 0) or (strchr_tab(my_tab, "\n") == nil)) then
+    io.write(s)
+    return
+  end
+
+  for i = 1, indent do
+    id[#id + 1] = ' '
+  end
+  indent_str = table.concat(id)
+
+  while(true) do
+    pos, subs = strchr_tab(str_to_tab(s), '\n')
+    if(subs == nil) then break end
+    io.write(table.concat(my_tab, "", 1, pos))
+    s = subs:sub(2)
+    my_tab = str_to_tab(s)
+    if(s ~= "") then
+      io.write(indent_str);
+    end
+  end
+  if(s) then
+    io.write(s)
+  end
+
+  -- restore context
+  io.output(ctx)
+end
+
diff --git a/src/skels/ifgen_lua.h_skel b/src/skels/ifgen_lua.h_skel
new file mode 100644
index 0000000..3179ee9
--- /dev/null
+++ b/src/skels/ifgen_lua.h_skel
@@ -0,0 +1,7 @@
+if (@exp@) then
+  @then_body@
+@if@ skipelse @then@end@else@
+else
+  @else_body@
+end@endif@
+
diff --git a/src/skels/initstructfun_lua.h_skel b/src/skels/initstructfun_lua.h_skel
new file mode 100644
index 0000000..c99d057
--- /dev/null
+++ b/src/skels/initstructfun_lua.h_skel
@@ -0,0 +1,4 @@
+
+function init_@structname@(record)
+  @genfieldinit:method{iteration=true}@
+end
diff --git a/src/skels/lua_convert.h_skel b/src/skels/lua_convert.h_skel
new file mode 100644
index 0000000..f6d9880
--- /dev/null
+++ b/src/skels/lua_convert.h_skel
@@ -0,0 +1,15 @@
+@IF@ hasints @THEN@
+
+function int_to_string(i)
+  return tostring(i)
+end
+
+@ENDIF@
+
+@IF@ hasbools @THEN@
+
+function bool_to_string(b)
+  return b
+end
+
+@ENDIF@
diff --git a/src/skels/outputluavar.h_skel b/src/skels/outputluavar.h_skel
new file mode 100644
index 0000000..51d0f39
--- /dev/null
+++ b/src/skels/outputluavar.h_skel
@@ -0,0 +1 @@
+(record.@name@) and record.@name@ or ""
diff --git a/src/skels/strcntfunction_lua.h_skel b/src/skels/strcntfunction_lua.h_skel
new file mode 100644
index 0000000..f579dee
--- /dev/null
+++ b/src/skels/strcntfunction_lua.h_skel
@@ -0,0 +1,6 @@
+
+function strcnt_@genname@(record, indent)
+  local length = 0;
+  @compleninstr:method@
+  return length + @constlen@;
+end
diff --git a/src/skelstruct_lua.cpp b/src/skelstruct_lua.cpp
new file mode 100644
index 0000000..bc98a5d
--- /dev/null
+++ b/src/skelstruct_lua.cpp
@@ -0,0 +1,308 @@
+//
+//
+// C++ Implementation: skelstruct_lua
+//
+// Description:
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#include "skelstruct_lua.h"
+#include "gengen_globals.h"
+#include "gengen_cmdline_options.h"
+#include "extern_function_lua.h"
+#include "skelstruct_strcnt_lua.h"
+#include "my_sstream.h"
+#include "callextfun_lua.h"
+#include "skelstruct_luastring.h"
+#include "genstringfun_lua.h"
+#include "lua_convert.h"
+#include "outputluavar.h"
+#include "streamstruct.h"
+#include "utils.h"
+#include "fileutil.h"
+
+#define struct_suffix "_gen_table"
+
+using std::endl;
+
+SkelStructLua::SkelStructLua(SkelItems *items,
+                             const string &name, const string &file_name,
+                             StreamStruct &s, bool sep_files) :
+  SkelStruct_Lua_Common (items, name, file_name, s, sep_files), num_of_methods (-1),
+  num_of_normal_strings (-1)
+{
+}
+
+SkelStructLua::~SkelStructLua()
+{
+}
+
+void
+SkelStructLua::generate()
+{
+  if (num_of_methods < 0)
+    analyze_items ();
+
+  string struct_name (name + struct_suffix);
+  string headername_include = struct_name;
+
+  Utils::toUpper(headername_include);
+
+  lua_header_gen_class::set_structname (struct_name);
+  initstructfun_lua_gen_class::set_structname (struct_name);
+
+  string author = "by " AUTHOR " " EMAIL;
+  string other_comments =  HOMEPAGE;
+
+  genfunction_lua_gen_class::set_genname (name);
+  strcntfunction_lua_gen_class::set_genname (name);
+  genstrfunction_lua_gen_class::set_genname (name);
+
+  lua_header_gen_class::set_package (PACKAGE);
+  if (! no_gen_version)
+    lua_header_gen_class::set_version (VERSION);
+  lua_header_gen_class::set_author (author);
+  lua_header_gen_class::set_othercomments (other_comments);
+  lua_source_gen_class::set_package (PACKAGE);
+  if (! no_gen_version)
+    lua_source_gen_class::set_version (VERSION);
+  lua_source_gen_class::set_author (author);
+  lua_source_gen_class::set_othercomments (other_comments);
+
+  // make sure to strip possible path
+  set_headerfile (strip_file_path(file_name));
+
+  generate_lua_header (*streamstruct.header_stream);
+
+  streamstruct.header_stream->flush ();
+}
+
+void
+SkelStructLua::generate_fields(ostream &stream, unsigned int indent)
+{
+  VarSetIterator it, end_it;
+  const VarSet &var_set = skel_struct->getVarSet();
+  string indent_string (indent, ' ');
+  skelitem_type item_type;
+
+  for (it = var_set.begin (); it != var_set.end (); ++it)
+    {
+      item_type = (*it)->getType ();
+      stream << indent_string;
+      stream << **it << ",\n";
+    }
+}
+
+void
+SkelStructLua::generate_genparameters(ostream &stream, unsigned int indent)
+{
+  VarSetIterator it;
+  const VarSet &var_set = skel_struct->getVarSet();
+  skelitem_type item_type;
+
+  for (it = var_set.begin (); it != var_set.end (); ++it)
+    {
+      item_type = (*it)->getType ();
+      stream << ", " << **it;
+    }
+}
+
+void
+SkelStructLua::generate_genstring(ostream &stream, unsigned int indent)
+{
+  if (sep_files)
+    return;
+
+  generate_genstringfun( stream, indent);
+}
+
+void
+SkelStructLua::generate_genstringfun(ostream &stream, unsigned int indent)
+{
+  if (! has_expand_strings ())
+    return;
+
+  genstringfun_lua_gen_class genstring;
+  genstring.generate_genstringfun_lua (stream, indent);
+}
+
+void
+SkelStructLua::generate_genconvfun(ostream &stream, unsigned int indent)
+{
+  if (! has_ints_to_generate() && ! has_booleans_to_generate())
+    return;
+
+  lua_convert_gen_class gen;
+  gen.set_hasints(has_ints_to_generate());
+  gen.set_hasbools(has_booleans_to_generate());
+  gen.generate_lua_convert (stream, indent);
+}
+
+void
+SkelStructLua::generate_genconv(ostream &stream, unsigned int indent)
+{
+  if (sep_files)
+    return;
+
+  generate_genconvfun (stream, indent);
+}
+
+void
+SkelStructLua::generate_genfieldinit(ostream &stream, unsigned int indent)
+{
+  VarSetIterator it;
+  const VarSet &var_set = skel_struct->getVarSet();
+  string indent_string (indent, ' ');
+  skelitem_type item_type;
+
+  for (it = var_set.begin (); it != var_set.end (); ++it)
+    {
+      item_type = (*it)->getType ();
+      if (isVariableType( item_type ))
+        {
+          stream << indent_string;
+          stream << "record." << **it << " = nil\n";
+        }
+    }
+}
+
+void
+SkelStructLua::generate_assignfields(ostream &stream, unsigned int indent)
+{
+  VarSetIterator it;
+  const VarSet &var_set = skel_struct->getVarSet();
+  string indent_string (indent, ' ');
+  skelitem_type item_type;
+
+  stream << endl;
+
+  for (it = var_set.begin (); it != var_set.end (); ++it)
+    {
+      item_type = (*it)->getType ();
+      if (isVariableType( item_type ))
+        {
+          stream << indent_string;
+          stream << "record." << **it << " = " << **it << "\n";
+        }
+    }
+}
+
+void
+SkelStructLua::generate_strgeninstructions(ostream &stream, unsigned int indent)
+{
+  SkelStructLuaString luastring_gen (*this);
+  luastring_gen.start_generation (stream, indent);
+}
+
+void
+SkelStructLua::generate_funbody(ostream &stream, unsigned int indent)
+{
+  if (sep_files)
+    {
+      generate_lua_source (*streamstruct.source_stream, 0);
+
+      streamstruct.source_stream->flush ();
+    }
+  else
+    {
+      generate_genfunction_lua (stream, 0);
+      generate_genstrfunction_lua (stream, 0);
+      generate_strcntfunction_lua (stream, 0);
+      generate_initstructfun_lua (stream, 0);
+    }
+}
+
+void
+SkelStructLua::generate_genfunbody(ostream &stream, unsigned int indent)
+{
+  generate_genfunction_lua (stream, 0);
+  generate_genstrfunction_lua (stream, 0);
+  generate_strcntfunction_lua (stream, 0);
+  generate_initstructfun_lua (stream, 0);
+}
+
+void
+SkelStructLua::generate_externfunctions(ostream &stream, unsigned int indent)
+{
+  VarSetIterator it;
+  const VarSet &var_set = skel_struct->getVarSet();
+  skelitem_type item_type;
+  extern_function_lua_gen_class extfun_gen_lua;
+
+  for (it = var_set.begin (); it != var_set.end (); ++it)
+    {
+      item_type = (*it)->getType ();
+
+      if (item_type == METHOD_TYPE)
+        {
+          extfun_gen_lua.set_name ((*it)->getText ());
+          extfun_gen_lua.generate_extern_function_lua (stream, indent);
+
+          stream << endl;
+          stream << endl;
+        }
+    }
+}
+
+void
+SkelStructLua::generate_geninstructions(ostream &stream, unsigned int indent)
+{
+  gen_generate_instructions (stream, indent);
+}
+
+void
+SkelStructLua::generate_compleninstr(ostream &stream, unsigned int indent)
+{
+  SkelStructStrCntLua strcnt (*this);
+
+  int const_len = strcnt.compute_length (stream, indent);
+
+  ostringstream const_len_s;
+  const_len_s << const_len;
+
+  set_constlen (const_len_s.str ());
+}
+
+void
+SkelStructLua::call_external_function(ostream &stream, const string &name,
+                                      unsigned int indent)
+{
+  callextfun_lua_gen_class callext;
+  callext.set_name (name);
+  callext.generate_callextfun_lua (stream, indent);
+  stream << endl;
+}
+
+void
+SkelStructLua::std_generation(ostream &stream, const string &s)
+{
+  stream << "io.write(" << s << ")\n";
+}
+
+void
+SkelStructLua::variable_generation(ostream &stream, const string &name,
+                                   const skelitem_type &type,
+                                   unsigned int indent)
+{
+  ostringstream luavar;
+
+  if (canBeString( type ) || expand_tabs) {
+    outputluavar_gen_class luavar_gen (name);
+    luavar_gen.generate_outputluavar (luavar);
+  } else {
+    luavar << field_prefix() << name;
+  }
+
+  // instead of relying on the convert functions, since printf
+  // can handle integers, we use this feature directly
+  if (expand_tabs)
+    stream << "generate_string (" + luavar.str () +
+      ", stream, indent + string.len (indent_str))\n";
+  else
+    stream << "io.write(" << luavar.str () << ")\n";
+}
diff --git a/src/skelstruct_lua.h b/src/skelstruct_lua.h
new file mode 100644
index 0000000..57018c4
--- /dev/null
+++ b/src/skelstruct_lua.h
@@ -0,0 +1,81 @@
+//
+//
+// C++ Interface: skelstruct_lua
+//
+// Description:
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#ifndef SKELSTRUCT_LUA_H
+#define SKELSTRUCT_LUA_H
+
+#include "skelstruct_lua_common.h"
+#include "lua_header.h"
+#include "genfunction_lua.h"
+#include "lua_source.h"
+#include "strcntfunction_lua.h"
+#include "initstructfun_lua.h"
+#include "genstrfunction_lua.h"
+
+/**
+ * Class for generation of Lua code
+ */
+class SkelStructLua : public SkelStruct_Lua_Common, public lua_header_gen_class,
+                      public genfunction_lua_gen_class, public lua_source_gen_class,
+                      public strcntfunction_lua_gen_class, public initstructfun_lua_gen_class,
+                      public genstrfunction_lua_gen_class
+{
+ protected:
+  int num_of_methods;
+  int num_of_normal_strings;
+
+ public:
+  // redefined from c_header_gen_class
+  virtual void generate_fields(ostream &stream, unsigned int indent);
+  virtual void generate_funbody(ostream &stream, unsigned int indent);
+  virtual void generate_externfunctions(ostream &stream, unsigned int indent);
+  virtual void generate_genparameters(ostream &stream, unsigned int indent);
+  virtual void generate_genstring(ostream &stream, unsigned int indent);
+  virtual void generate_genconv(ostream &stream, unsigned int indent);
+
+  // redefined from genfunction_gen_class
+  virtual void generate_geninstructions(ostream &stream, unsigned int indent);
+  virtual void generate_assignfields(ostream &stream, unsigned int indent);
+
+  // redefined from c_source_gen_class
+  virtual void generate_genfunbody(ostream &stream, unsigned int indent);
+  virtual void generate_genstringfun(ostream &stream, unsigned int indent);
+  virtual void generate_genconvfun(ostream &stream, unsigned int indent);
+
+  // redefined from strcntfunction_gen_class
+  virtual void generate_compleninstr(ostream &stream, unsigned int indent);
+
+  // redefined from initstructfun_gen_class
+  virtual void generate_genfieldinit(ostream &stream, unsigned int indent);
+
+  // redefined from genstrfunction_gen_class
+  virtual void generate_strgeninstructions(ostream &stream, unsigned int indent);
+
+  // redefined from SkelStruct
+  virtual void call_external_function(ostream &stream, const string &name,
+                                      unsigned int indent);
+  virtual void std_generation(ostream &stream, const string &s);
+  virtual void variable_generation(ostream &stream, const string &name,
+                                   const skelitem_type &t,
+                                   unsigned int indent);
+
+ public:
+  SkelStructLua (SkelItems *items,
+                 const string &n, const string &file_name, StreamStruct &s,
+                 bool sep_files);
+  virtual ~SkelStructLua();
+
+  virtual void generate();
+};
+
+#endif // SKELSTRUCT_LUA_H
diff --git a/src/skelstruct_lua_common.cpp b/src/skelstruct_lua_common.cpp
new file mode 100644
index 0000000..39f2ff9
--- /dev/null
+++ b/src/skelstruct_lua_common.cpp
@@ -0,0 +1,63 @@
+//
+// C++ Implementation: skelstruct_lua_common
+//
+// Description:
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#include "skelstruct_lua_common.h"
+#include "ifgen_lua.h"
+#include "expressiongenerator_lua.h"
+
+using std::endl;
+
+SkelStruct_Lua_Common::SkelStruct_Lua_Common(SkelItems* items, const string& n, const string& file, StreamStruct& s, bool sep): SkelStruct(items, n, file, s, sep), expGen (0)
+{
+}
+
+SkelStruct_Lua_Common::~SkelStruct_Lua_Common()
+{
+  if (expGen && !is_copy)
+    delete expGen;
+}
+
+void
+SkelStruct_Lua_Common::if_generation(const string &exp, const string &then_branch,
+                             const string &else_branch, ostream &stream,
+                             unsigned int indent)
+{
+  bool empty_else = (!else_branch.size());
+  
+  ifgen_lua_gen_class ifgen;
+  ifgen.set_exp (exp);
+  ifgen.set_then_body (then_branch);
+  ifgen.set_else_body (else_branch);
+  ifgen.set_skipelse (empty_else);
+
+  ifgen.generate_ifgen_lua (stream, indent);
+
+  stream << endl;
+}
+
+
+void
+SkelStruct_Lua_Common::exp_generation(Expression *exp, ostream &stream)
+{
+  if (!expGen) {
+    expGen = createExpGenLua(stream);
+    expGen->setPrefix( field_prefix() );
+  } else {
+    expGen->setStream( stream );
+  }
+
+  expGen->visit_DB( exp );
+}
+
+ExpressionGeneratorLua *SkelStruct_Lua_Common::createExpGenLua(ostream &stream)
+{
+  return new ExpressionGeneratorLua(stream);
+}
diff --git a/src/skelstruct_lua_common.h b/src/skelstruct_lua_common.h
new file mode 100644
index 0000000..d34f63f
--- /dev/null
+++ b/src/skelstruct_lua_common.h
@@ -0,0 +1,51 @@
+//
+// C++ Interface: skelstruct_lua_common
+//
+// Description:
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#ifndef SKELSTRUCT_LUA_COMMON_H
+#define SKELSTRUCT_LUA_COMMON_H
+
+#include "skelstruct.hpp"
+
+#include "my_sstream.h"
+
+class ExpressionGeneratorLua;
+
+/**
+A base class that contains shared methods for Lua related generation code
+
+@author Raman Gopalan
+*/
+class SkelStruct_Lua_Common : public SkelStruct
+{
+  protected:
+    /// the generator for expressions
+    ExpressionGeneratorLua *expGen;
+
+  public:
+    SkelStruct_Lua_Common(SkelItems* items, const string& n, const string& file, StreamStruct& s, bool sep);
+    virtual ~SkelStruct_Lua_Common();
+
+    virtual void if_generation(const string &exp, const string &then_branch,
+                             const string &else_branch, ostream &stream,
+                             unsigned int indent);
+    virtual const string field_prefix() { return "record."; }
+
+    virtual void exp_generation( Expression *exp, ostream &stream );
+
+    /**
+     * This is the factory method used to create an ExpressionGenerator for Lua
+     *
+     * @return The created ExpressionGenerator
+     */
+    virtual ExpressionGeneratorLua *createExpGenLua(ostream &stream);
+};
+
+#endif // SKELSTRUCT_LUA_COMMON_H
diff --git a/src/skelstruct_luastring.cpp b/src/skelstruct_luastring.cpp
new file mode 100644
index 0000000..404b5fe
--- /dev/null
+++ b/src/skelstruct_luastring.cpp
@@ -0,0 +1,54 @@
+//
+// C++ Implementation: skelstruct_luastring
+//
+// Description: generate into a Lua string instead of into a file
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#include "skelstruct_luastring.h"
+
+SkelStructLuaString::SkelStructLuaString(const SkelStruct_Lua_Common &s) :
+  SkelStruct_Lua_Common (s)
+{
+  do_indent_update = false;
+}
+
+void
+SkelStructLuaString::call_external_function(ostream &stream, const string &name,
+                                            unsigned int indent)
+{
+  variable_generation (stream, name, STRING_TYPE, indent);
+}
+
+void
+SkelStructLuaString::std_generation(ostream &stream, const string &s)
+{
+  stream << "output = output .. " << s << "\n";
+}
+
+void
+SkelStructLuaString::variable_generation(ostream &stream, const string &name,
+                                         const skelitem_type &type,
+                                         unsigned int indent)
+{
+  if (canBeString( type )) {
+    stream << "if (record." << name << ") then ";
+    std_generation (stream, "record." + name + " end");
+  } else if (type == BOOL_TYPE) {
+    std_generation (stream, "bool_to_string(record." + name + ")");
+  } else if (type == INT_TYPE) {
+    std_generation (stream, "int_to_string(record." + name + ")");
+  }
+}
+
+void
+SkelStructLuaString::start_generation(ostream &stream, unsigned int indent)
+{
+  gen_generate_instructions (stream, indent);
+}
+
diff --git a/src/skelstruct_luastring.h b/src/skelstruct_luastring.h
new file mode 100644
index 0000000..3e0df69
--- /dev/null
+++ b/src/skelstruct_luastring.h
@@ -0,0 +1,35 @@
+//
+// C++ Interface: skelstruct_luastring
+//
+// Description: generate into a Lua string instead of into a file
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#ifndef SKELSTRUCT_LUASTRING_H
+#define SKELSTRUCT_LUASTRING_H
+
+#include "skelstruct_lua_common.h"
+
+class SkelStructLuaString : public SkelStruct_Lua_Common
+{
+ public:
+  // redefined from SkelStruct
+  virtual void call_external_function(ostream &stream, const string &name,
+                                      unsigned int indent);
+  virtual void std_generation(ostream &stream, const string &s);
+  virtual void variable_generation(ostream &stream, const string &name,
+                                   const skelitem_type &t,
+                                   unsigned int indent);
+
+ public:
+  SkelStructLuaString (const SkelStruct_Lua_Common &s);
+
+  void start_generation (ostream &stream, unsigned int indent);
+};
+
+#endif // SKELSTRUCT_LUASTRING_H
diff --git a/src/skelstruct_strcnt_lua.cpp b/src/skelstruct_strcnt_lua.cpp
new file mode 100644
index 0000000..726cc22
--- /dev/null
+++ b/src/skelstruct_strcnt_lua.cpp
@@ -0,0 +1,88 @@
+//
+//
+// C++ Implementation: skelstruct_strcnt_lua
+//
+// Description: to compute the lenght of the string to be generated
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#include "skelstruct_strcnt_lua.h"
+
+SkelStructStrCntLua::SkelStructStrCntLua(const SkelStruct_Lua_Common &s) :
+  SkelStruct_Lua_Common (s), length (0)
+{
+}
+
+void
+SkelStructStrCntLua::call_external_function(ostream &stream, const string &name,
+                                            unsigned int indent)
+{
+  variable_generation (stream, name, STRING_TYPE, indent);
+}
+
+void
+SkelStructStrCntLua::std_generation(ostream &stream, const string &s)
+{
+  int size = s.size();
+  if (s == "\\n" || s == "\\t")
+    size = 1;
+  //std::cerr << "string: \"" << s << "\", length: " << size << std::endl;
+  length += size;
+}
+
+void
+SkelStructStrCntLua::std_indentstr_generation(ostream &stream, const string &s,
+                                              unsigned int indent)
+{
+  //std::cerr << "string: " << s << ", length: " << indent << std::endl;
+  length += indent;
+}
+
+void
+SkelStructStrCntLua::indent_generation(ostream &stream, const string &ind)
+{
+}
+
+void
+SkelStructStrCntLua::variable_generation(ostream &stream, const string &name,
+                                         const skelitem_type &type,
+                                         unsigned int indent)
+{
+  if (examined_variables.find (name) == examined_variables.end ())
+    {
+      string indent_string (indent, ' ');
+      stream << indent_string;
+      stream << "length = length + ";
+      if (canBeString( type )) {
+         stream << "((record." << name << ") " <<
+             "and string.len(record." << name << ") or 0)";
+      } else if (type == BOOL_TYPE) {
+        stream << "string.length(bool_to_string(record." << name
+            << "))";
+      } else if (type == INT_TYPE) {
+        stream << "string.len(int_to_string(record." << name
+            << "))";
+      }
+      stream << " * " <<
+         skel_struct->getVarOccurCnt(name) << ";\n";
+      examined_variables.insert (name);
+    }
+}
+
+void
+SkelStructStrCntLua::indent_update_generation(ostream &stream, int i)
+{
+}
+
+int
+SkelStructStrCntLua::compute_length (ostream &stream, int indent)
+{
+  gen_generate_instructions (stream, indent);
+
+  return length;
+}
